int sockbind(char *host, char *serv, int prot, int type) 
{
    struct addrinfo hint, *addr;
    int res;
    int sock;
    /* initialize hint structure */
    memset(&hint, 0, sizeof(struct addrinfo)); 
    hint.ai_flags = AI_PASSIVE;          /* address for binding */
    hint.ai_family = PF_UNSPEC;          /* generic address (IPv4 or IPv6) */
    hint.ai_protocol = prot;             /* protocol */
    hint.ai_socktype = type;             /* socket type */
    res = getaddrinfo(host, serv, &hint, &addr);   /* calling getaddrinfo */
    if (res != 0) {                                /* on error exit */
	printf("sockbind cannot resolve host %s, service %s, ", host, serv);
	printf("protocol %d: %s\n", prot, gai_strerror(res));
	return -1;
    }
    /* get a socket */
    sock = socket(addr->ai_family, addr->ai_socktype, addr->ai_protocol);
    if (sock < 0) {
	printf("sockconn cannot create socket\n");
	return sock;
    }
    /* connect the socket */
    res = bind(sock, addr->ai_addr, addr->ai_addrlen);
    if (res < 0) {
	printf("sockconn cannot bind socket\n");
	return res;
    }
    freeaddrinfo(addr);         /* done, release memory */
    return sock;
}
